/*
 * Copyright (C) 2013 Darth Affe <http://wyrez.org> and contributors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package org.wyrez.shootingstars.factories;

import com.jme3.asset.AssetManager;
import com.jme3.material.Material;
import com.jme3.math.ColorRGBA;

/**
 *
 * @author Darth Affe
 */
public enum Materials {

    UNSHADED("Common/MatDefs/Misc/Unshaded.j3md", null, null, null),
    HEX("Common/MatDefs/Light/Lighting.j3md", "Textures/hex.png", null, null),
    WEAPON("Common/MatDefs/Light/Lighting.j3md", null, ColorRGBA.White, ColorRGBA.Cyan),
    GLOW("Common/MatDefs/Light/Lighting.j3md", null, ColorRGBA.White, ColorRGBA.Black),
    STAR("Common/MatDefs/Misc/Unshaded.j3md", null, null, null);
    private static AssetManager assetManager;
    private String material;
    private String texture;
    private ColorRGBA color;
    private ColorRGBA glowColor;

    Materials(String material, String texture, ColorRGBA color, ColorRGBA glowColor) {
        this.material = material;
        this.texture = texture;
        this.color = color;
        this.glowColor = glowColor;
    }

    public Material create() {
        Material mat = new Material(assetManager, material);
        if (texture != null) {
            mat.setTexture("DiffuseMap", assetManager.loadTexture(texture));
        }
        if (color != null) {
            mat.setColor("Diffuse", color);
        }
        if (color != null) {
            mat.setColor("GlowColor", glowColor);
        }
        return mat;
    }

    public static void initialize(AssetManager assetManager) {
        Materials.assetManager = assetManager;
    }
}
